c-----------------------------------------------------------------------
c
c     M A I N   D A T A   S T R U C T U R E
c
c     For storing/manipulating arbitrary number of grid functions
c     defined on an arbitrary number of distinct lattices.
c
c     Non-parameter values stored in common block / com_gfuni0 /
c     although common facility may not actually be used.
c
c-----------------------------------------------------------------------

c-----------------------------------------------------------------------
c     Declarations for functions for extracting lattice information
c     (rank, shape, coordinates etc. from ptrs() array 
c-----------------------------------------------------------------------
      integer         getnlat,   getlatid,  getrank,  getpshape,  
     &                getshape,  getpcoord, getsize, getpbounds,
     &                getbounds, getlatcs

      external        getnlat,   getlatid,  getrank,  getpshape,  
     &                getshape,  getpcoord, getsize, getpbounds,
     &                getbounds, getlatcs
C-----------------------------------------------------------------------
C
C     Storage for dynamic allocation
C
C-----------------------------------------------------------------------
			real*8          q(memsiz)
			common        / com_gfuni0 / q
c-----------------------------------------------------------------------
c     Maximum rank of a grid function 
c-----------------------------------------------------------------------
      integer         maxrank
      parameter     ( maxrank = 5 )
c-----------------------------------------------------------------------
c     Maximum iterations 
c-----------------------------------------------------------------------
      integer         MAXSTEP
      parameter     ( MAXSTEP = 50 )
c-----------------------------------------------------------------------
c     Lattice Control Block  :=
c
c (id, cs, rank, shape(1) ... shape(maxrank),
c  bounds(1) ... bounds(2*maxrank), cptr(1) ... cptr(maxrank))
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
c     Size of a lattice control block
c-----------------------------------------------------------------------
      integer         sizelatcb
      parameter     ( sizelatcb = 3 + 4 * maxrank )
c-----------------------------------------------------------------------
c     Maximum  # of grid functions 
c-----------------------------------------------------------------------
      integer         maxgfcn
      parameter     ( maxgfcn = 100 )
c-----------------------------------------------------------------------
c     Total # of grid functions (count distinct time levels separately)
c-----------------------------------------------------------------------
      integer         ngfcn
      common        / com_gfuni0 / ngfcn
c-----------------------------------------------------------------------
c     Maximum possible length of pointers array 
c-----------------------------------------------------------------------
      integer         maxptrs
      parameter     ( maxptrs = maxgfcn * (2 + sizelatcb) )
c-----------------------------------------------------------------------
c     Pointers array and actual length 
c
c     ptrs(1:ngfcn)         := Pointers to associated storage in q()
c     ptrs(ngfcn+1:2*ngfcn) := Pointers to latlcb's in ptrs()
c     ptrs(2*ngfcn:nptrs)   := Storage for latlcb's
c-----------------------------------------------------------------------
      integer         ptrs(maxptrs)
      common        / com_gfuni0 /  ptrs
      integer         nptrs
      common        / com_gfuni0 /  nptrs

